const fs = require('fs');
const path = require('path')

window.fs = fs;
window.F_OK = fs.F_OK;
window.path = path;

diClass = require("@brightsign/deviceinfo");
window.di = new diClass(); 
window.fileName = '/storage/sd/LocalStore/localStore.txt';

let FileSystemInfoClass = require("@brightsign/filesysteminfo");

function detectUSB(){
    return new Promise((resolve, reject) => {
        let fileSystemInfo = new FileSystemInfoClass("/storage/usb1");
        fileSystemInfo.getStatistics().then(
                function(data) {
                    if(data.bytesFree){
                        console.log("USB Available")
                        resolve(1);
                    }
                })
            .catch(
                function(data) {
                    console.log("fileSystemInfo error",data)
                    reject(0)
                });
    })
}

function calculateAvailableStorage(dir){
    return new Promise((resolve, reject) => {
        let fileSystemInfo = new FileSystemInfoClass(dir);
        fileSystemInfo.getStatistics().then(
        function(data) {
            if(data.bytesFree){
                console.log("fileSystemInfo storage",data.bytesFree)
                resolve(data.bytesFree);
            }else{
                console.log(`Error checking ${dir} storage`,JSON.stringify(data));
                reject("ERROR");
            }
        })
    .catch(
        function(data) {
            console.log("fileSystemInfo error",data)
            reject(0)
        });
    })
}

function calculateFullStorage(usb){
    const storage = {};
    return new Promise((resolve, reject) => {
        let fileSystemInfo = new FileSystemInfoClass("/storage/sd");
        fileSystemInfo.getStatistics().then(
            function(data) {
                if(data.bytesFree){
                    storage.internalFreeSpace = data.bytesFree;
                    storage.internalUsedSpace = data.sizeBytes - data.bytesFree;
                    if(usb){
                        let fileSystemInfo = new FileSystemInfoClass("/storage/usb1");
                        fileSystemInfo.getStatistics().then(
                            function(data) {
                                if(data.bytesFree){
                                    storage.usbFreeSpace = data.bytesFree;
                                    storage.usbUsedSpace = data.sizeBytes - data.bytesFree;
                                    resolve(storage);
                                }else{
                                    console.log(`Error checking usb storage`,JSON.stringify(data));
                                    reject('ERROR');
                                }
                            })
                        .catch(
                            function(data) {
                                console.log(`calculateFullStorage error`,data);
                                reject(0)
                            });
                    }else{
                        resolve(storage);
                    }
                }
                else{
                   console.log(`Error checking internal storage`,JSON.stringify(data));
                    reject('ERROR'); 
                }
            })
        .catch(
            function(data) {
                console.log(`calculateFullStorage error`,data);
                reject(0)
            });
    })    
}

window.calculateAvailableStorage = calculateAvailableStorage;
window.calculateFullStorage = calculateFullStorage;
window.detectUSB = detectUSB;

